#region Using declarations
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Input;
using System.Windows.Media;
using System.Xml.Serialization;
using NinjaTrader.Cbi;
using NinjaTrader.Gui;
using NinjaTrader.Gui.Chart;
using NinjaTrader.Gui.SuperDom;
using NinjaTrader.Gui.Tools;
using NinjaTrader.Data;
using NinjaTrader.NinjaScript;
using NinjaTrader.Core.FloatingPoint;
using NinjaTrader.NinjaScript.DrawingTools;
#endregion

//This namespace holds Indicators in this folder and is required. Do not change it. 
namespace NinjaTrader.NinjaScript.Indicators
{
	public class CKv9WithBoxesMidBandAndPhantom : Indicator
	{
		private double              line0;
		private double 				line8;
		private double 				MidBandDir;
		private double 				BackRoundDir; 
	    bool MidBandisBlue   =  	false;
   	   	bool MidBandisRed  = 		false;
		bool BackRoundUp  = 		false;
		bool BackRoundDn  = 		false;
		private Brush user1 = 		Brushes.Red;
		private double 				lastMidBandLongHigh;
		private double 				LastMidBandShortLow;
		bool MidBandLongOn = 		false;
		bool MidBandLongFirstTime = false;
		bool MidBandShortOn =		false;
		bool MidBandShortFirstTime =false;
		private double 				LastPhantomLongHigh;
		private double 				LastPhantomShortLow;
		bool PhantomLongOn = 		false;
	    bool PhantomShortOn = 		false;
		bool PhantomLongFirstTime = false;
		bool PhantomShortFirstTime= false;
		
		
		
		protected override void OnStateChange()
		{
			if (State == State.SetDefaults)
			{
				
				Description									= @"Enter the description for your new custom Indicator here.";
				Name										= "CKv9WithBoxesMidBandAndPhantom";
				Calculate									= Calculate.OnBarClose;//OnEachTick
				IsOverlay									= true;
				DisplayInDataBox							= true;
				DrawOnPricePanel							= true;
				DrawHorizontalGridLines						= true;
				DrawVerticalGridLines						= true;
				PaintPriceMarkers							= false;
				ScaleJustification							= NinjaTrader.Gui.Chart.ScaleJustification.Right;
				//Disable this property if your indicator requires custom values that cumulate with each new market data event. 
				//See Help Guide for additional information.
				IsSuspendedWhileInactive		= true;
				TickRange				 		= 48;
				TicksBetweenLines				= 6;
				TicksAwayFromBox				= 15;
				BackRoundColorUp = new SolidColorBrush(Color.FromArgb(80,60, 179, 113));
				BackRoundColorUp.Freeze();
				BackRoundColorDown = new SolidColorBrush(Color.FromArgb(60,255, 0, 0));
				BackRoundColorDown.Freeze();
				LongPhantomColor = new SolidColorBrush(Color.FromArgb(20,255, 255, 0));
				LongPhantomColor.Freeze();
				ShortPhantomColor = new SolidColorBrush(Color.FromArgb(20,255, 0, 0));
				ShortPhantomColor.Freeze();
				
				
				MidBandColor					= Brushes.Green;
				BackRoundColor					= Brushes.Green;
				MidBandDir                      = 0;
				BackRoundDir					= 0;
				ShowBackRoundColors				= true;
				BackRoundUp						= false;
				BackRoundDn						= false;
				ShowTradeText                   = true;
				ShowTradeEntryLine				= true;
				ShowTradeBoxes					= true;
			
				AddPlot(Brushes.Transparent, "Line0");
				AddPlot(Brushes.Transparent, "Line1");
				AddPlot(new Stroke(Brushes.Red,DashStyleHelper.Solid,2,100), PlotStyle.Line,"Line2");
				AddPlot(Brushes.Transparent, "Line3");
				AddPlot(new Stroke(Brushes.Yellow,DashStyleHelper.Solid,6,100), PlotStyle.Line,"Line4");
				AddPlot(Brushes.Transparent, "Line5");
				AddPlot(new Stroke(Brushes.Green,DashStyleHelper.Solid,2,100), PlotStyle.Line,"Line6");
				AddPlot(Brushes.Transparent, "Line7");
				AddPlot(Brushes.Transparent, "Line8");
				
				
			}
			else if (State == State.Configure)
			{
			}
		}

		protected override void OnBarUpdate()
		{
			 if (CurrentBar == 5)
			
            {
                line8 = Close[0];
                line0 = Close[0];
            }
			// if lines are moving up
            if (High[0] > line8) 
            {
                line8 = High[0];
                line0 = line8 - TickRange * TickSize;
				MidBandisRed = false;
				PlotBrushes[4][0] = Brushes.Green;
				MidBandColor = Brushes.Green;
				MidBandDir = 1;
				MidBandShortFirstTime = true;
				MidBandLongFirstTime = true;
				PhantomLongFirstTime = true;
				//if it is high if session
				if (High[0] == (CurrentDayOHL().CurrentHigh[0])) 
					{
					PlotBrushes[4][0]  = Brushes.Blue;
					MidBandColor  = Brushes.Blue;
					MidBandisBlue  = true;
					}
  				
				BackRoundColor =  BackRoundColorUp;
					if (ShowBackRoundColors	)
					{
					BackBrushAll = BackRoundColor;
					}	
				BackRoundDir =1;
								
            }
			//if lines are going down
            else if (Low[0] < line0)
            {
                line0 = Low[0];
                line8 = line0 + TickRange * TickSize;
				MidBandisBlue  = false;	
				PlotBrushes[4][0] = Brushes.Magenta;
				MidBandColor = Brushes.Magenta;
				MidBandDir = 0;
				MidBandLongFirstTime = true;
				MidBandShortFirstTime = true;
				PhantomShortFirstTime = true;
				//MidBandLongOn = false;
				//if it is the low of the session
				if ((MidBandDir == 0 ) && (Low[0] == (CurrentDayOHL().CurrentLow[0]))  )
					{
					PlotBrushes[4][0]  = Brushes.Red;
					MidBandColor  = Brushes.Red;
					MidBandisRed  = true;
					
					}
				
				BackRoundColor  =  BackRoundColorDown;
					if (ShowBackRoundColors	)
					{
					BackBrushAll = BackRoundColor;
					}	
				
				BackRoundDir  = 0;
				
            }

			double line1 = (line0 + (TicksBetweenLines*1) * TickSize);
            double line2 = (line0 + (TicksBetweenLines*2) * TickSize);
            double line3 = (line0 + (TicksBetweenLines*3) * TickSize);
		    double line4 = (line0 + (TicksBetweenLines*4) * TickSize);
		    double line5 = (line0 + (TicksBetweenLines*5) * TickSize);
            double line6 = (line0 + (TicksBetweenLines*6) * TickSize);
            double line7 = (line0 + (TicksBetweenLines*7) * TickSize);
			
			// Calulating for midband colors when it transtioning
			
			   // when midband is in transistion from green
			if ((MidBandDir == 1 ) && ((Low[0] <= line1) && (Close[0] >= (line0))))
					{
					PlotBrushes[4][0] = Brushes.Yellow;
		  			MidBandColor = Brushes.Yellow;	
					}
					
			//when midband is in transition from red
			if ((MidBandDir == 0 ) && (High[0] >= (line0 + ((TicksBetweenLines * 7)  * TickSize))) && (Close[0] < (line8 + ((TicksBetweenLines * 7)  * TickSize))))
					{
					PlotBrushes[4][0] = Brushes.Yellow;
		  			MidBandColor = Brushes.Yellow;	
					}	
								
			PlotBrushes[4][0] = MidBandColor; 	 
					
			// Back round color for phamton zones ////////////////////////////////
					// phamton up
			if(!BackRoundDn)
				{
					if ((BackRoundDir == 1 ) && (Close[0] < line2) && (Close[0] > (line1)))// - ((TicksBetweenLines * 8)  * TickSize))))	 
					{
					BackRoundColor = Brushes.LightGoldenrodYellow;
					}	
					if ((BackRoundDir == 1 ) && (Close[0] < line1) && (Close[0] > (line0)))// - ((TicksBetweenLines * 8)  * TickSize))))	 
					{
					BackRoundColor = BackRoundColorDown;
						BackRoundDn = true;
						BackRoundUp = false;
					}	
					if ((BackRoundDir == 1 ) && (High[0] > line7) && (Close[0] < (line8)))	 
						{
						BackRoundColor = BackRoundColorUp;	
						}	
				}
				
				//Phamton down
				if(!BackRoundUp)
					{
						if ((BackRoundDir == 0 ) && (Close[0] > line6) && (Close[0] < (line8)))	 
						{
						BackRoundColor = Brushes.Pink;
						}	
						if ((BackRoundDir == 0 ) && (Close[0] > line7) && (Close[0] < (line8)))	 
						{
						BackRoundColor = BackRoundColorUp;
							BackRoundUp = true;
							BackRoundDn = false;
						}	
					if ((BackRoundDir == 0 ) && (Low[0] < line1) && (Close[0] > (line0)))	 
						{
						BackRoundColor = BackRoundColorDown;	
						}	
				}
				
				
				if (ShowBackRoundColors	)
				{
				BackBrushAll = BackRoundColor;	
				}	
				
				// box drawing code//////////////////////////////////////////////////////////////////////////////////////////////
				
				// for long mid band boxes
				if((BackRoundDir ==1) && (MidBandLongFirstTime))
				{
					if((Close[0] < (line5 -.02)) && (Low[0] < Low[1]) && (Close[0] > line3))
					{
					if(ShowTradeBoxes)
					{	
					Draw.Rectangle(this, "MidBandLongBoxT", true, 5, High[1] , 0, Low[0] , Brushes.Red, Brushes.PaleGreen, 4);	
					}
						lastMidBandLongHigh = High[1];	
						Print(lastMidBandLongHigh);	
					MidBandLongOn = true;	
						Print("First MidBand Longbox");
					}
					if(Close[0] < line3)
					{
				   MidBandLongOn = false;	
					MidBandLongFirstTime = false;	
						Print("below line 3");
					}
					
					if((Close[0] > lastMidBandLongHigh) && (MidBandLongOn))
					{
					RemoveDrawObject("MidBandLongBoxT");
						 // store the highest bars ago value
  						int lowestBarsAgo = LowestBar(Low,6 );
   						//evaluate high price from highest bars ago value
  						double lowestPrice = Low[lowestBarsAgo];  
						Print(string.Format("Lowest price of the last 6 Bars : {0} - occurred {1} bars ago", lowestPrice, lowestBarsAgo));
					if(ShowTradeEntryLine)
						{	
					Draw.Line(this,Convert.ToString(CurrentBars[0])+ @"LongMidBandEntry", true, 4, Close[0], -4, Close[0], false, "CKv9WithBoxesEntryLine" );		
						}
							if(ShowTradeBoxes)
					{	
					Draw.Rectangle(this, Convert.ToString(CurrentBars[0])+ @"MidBandLongBoxP",  5, High[lowestBarsAgo +1] , -5, Low[lowestBarsAgo] , false,"Ckv8Boxes" );
					}
					if(ShowTradeText)
					{	
					Draw.Text(this,Convert.ToString(CurrentBars[0])+ @"Mid Band Long","MidBand\nLong",  0 , (lowestPrice) -((TicksAwayFromBox) * (TickSize)),false ,"CKv9TradeTextLong");	
					}
					
					MidBandLongOn = false;	
					MidBandLongFirstTime = false;
						Print("Permanent MidBand Long Box");
				    }
				}		
					
					
						//for phantom long boxes////////////////////////
					
					if ((BackRoundDir == 1 ) && (PhantomLongFirstTime))
					{	
						if((Close[0] < (line2 -.01)) && (Low[0] < Low[1]) && (Close[0] > line0))
				   		{
						Draw.Rectangle(this, "PhantomLongBoxT", true, 5, High[1] , -5, Low[0] , Brushes.Red, Brushes.PaleGreen, 4);	
						LastPhantomLongHigh = High[1];	
						Print(LastPhantomLongHigh);	
						PhantomLongOn = true;
						PhantomShortOn	= false;
						Print("First Phantom Long box");
						}	
					 		  if((Close[0] > LastPhantomLongHigh) && (PhantomLongOn))
								{
									RemoveDrawObject("PhantomLongBoxT");
									 // store the highest bars ago value
  									int lowestBarsAgo = LowestBar(Low,6 );
   									//evaluate high price from highest bars ago value
  									double lowestPrice = Low[lowestBarsAgo];  
									Print(string.Format("Lowest price of the last 6 Bars for Phaontom: {0} - occurred {1} bars ago", lowestPrice, lowestBarsAgo));
									if(ShowTradeEntryLine)
									{	
									Draw.Line(this,Convert.ToString(CurrentBars[0])+ @"PhantomLongEntry", true, 4, Close[0], -4, Close[0], false, "CKv9WithBoxesEntryLine" );		
									}
										if(ShowTradeBoxes)
									{	
									Draw.Rectangle(this, Convert.ToString(CurrentBars[0])+ @"PhantomLongBoxP",  5, High[lowestBarsAgo +1] , -5, Low[lowestBarsAgo] , false,"Ckv8Boxes" );
									}
									if(ShowTradeText)
									{	
									Draw.Text(this,Convert.ToString(CurrentBars[0])+ @"Phantom Long","Phantom\nLong",  0 , (lowestPrice -((TicksAwayFromBox) * (TickSize))),false,"CKv9TradeTextLong" );
									}
									
									PhantomLongOn = false;	
									PhantomLongFirstTime = false;
									Print("Permanent Phantom Long Box");
								}	
					   }	
									
				
				// for mid band short boxes
				
				if((BackRoundDir ==0) && (MidBandShortFirstTime))
				{
					if((Close[0] > (line3 +.02)) && (High[0] > High[1]) && (Close[0] < line5))
					{
					if(ShowTradeBoxes)
					{	
						Draw.Rectangle(this, "MidBandShortBoxT", true, 5, Low[1] , 0, High[0] , Brushes.Red, Brushes.PaleGreen, 4);	
					}
						LastMidBandShortLow = Low[1];	
						Print(LastMidBandShortLow);	
					MidBandShortOn = true;	
						Print("First Short box");
					}
					if(Close[0] > line5)
					{
				   MidBandShortOn = false;	
				   MidBandShortFirstTime = false;	
						Print("Above line 5");
					}
					
						if((Close[0] < LastMidBandShortLow) && (MidBandShortOn))
						{
						RemoveDrawObject("MidBandShortBoxT");
						 // store the highest bars ago value
  						int highestBarsAgo = HighestBar(High,6 );
 
  						//evaluate high price from highest bars ago value
  						double highestPrice = High[highestBarsAgo];  
						Print(string.Format("Highest price of the last 6 Bars : {0} - occurred {1} bars ago", highestPrice, highestBarsAgo));
						if(ShowTradeEntryLine)
						{	
							Draw.Line(this,Convert.ToString(CurrentBars[0])+ @"ShortMidBandEntry", true, 4, (Close[0]), -4, Close[0], false, "CKv9WithBoxesEntryLine" );	
						}
							if(ShowTradeBoxes)
						{	
							Draw.Rectangle(this, Convert.ToString(CurrentBars[0])+ @"MidBandShortBoxP",  5, Low[(highestBarsAgo + 1) ] , -5, High[highestBarsAgo] , false,"Ckv8Boxes" );
						}	
							if(ShowTradeText)
						{		
						Draw.Text(this,Convert.ToString(CurrentBars[0])+ @"Mid Band Short","MidBand\nShort",  0 , (highestPrice +((TicksAwayFromBox) * (TickSize))),false,"CKv9TradeTextShort" );	
						}	
							
						MidBandShortOn = false;	
						MidBandShortFirstTime = false;
						Print("2nd Short Box");
				    }
				}
				
							//for phantom Short boxes////////////////////////
					
					if ((BackRoundDir == 0 ) && (PhantomShortFirstTime))
					{	
						if((Close[0] > (line6 -.01)) && (High[0] > High[1]) && (Close[0] < line8))
				   		{
						if(ShowTradeBoxes)
						{	
							Draw.Rectangle(this, "PhantomShortBoxT", true, 5, Low[1] , -5, High[0] , Brushes.Red, Brushes.PaleGreen, 4);	
						}	
							LastPhantomShortLow = Low[1];	
						Print(LastPhantomShortLow);	
						PhantomShortOn = true;
						PhantomLongOn = false;
						Print("First Phantom Short box");
						}	
					 		  if((Close[0] < LastPhantomShortLow) && (PhantomShortOn))
								{
									RemoveDrawObject("PhantomShortBoxT");
									 // store the highest bars ago value
  									int highestBarsAgo = HighestBar(High,6 );
   									//evaluate high price from highest bars ago value
  									double highestPrice = High[highestBarsAgo];  
									Print(string.Format("Hightest price of the last 6 Bars for Phaontom: {0} - occurred {1} bars ago", highestPrice, highestBarsAgo));
									if(ShowTradeEntryLine)
									{	
									Draw.Line(this,Convert.ToString(CurrentBars[0])+ @"PhantomShortEntry", true, 4, Close[0], -4, Close[0], false, "CKv9WithBoxesEntryLine" );		
									}
									if(ShowTradeBoxes)
									{	
									Draw.Rectangle(this, Convert.ToString(CurrentBars[0])+ @"PhantomShortBoxP",  5, Low[highestBarsAgo +1] , -5, High[highestBarsAgo] , false,"Ckv8Boxes" );
									}
									if(ShowTradeText)
									{	
									Draw.Text(this,Convert.ToString(CurrentBars[0])+ @"Phantom Short","Phantom\nShort",  0 , (highestPrice +((TicksAwayFromBox) * (TickSize))), false,"CKv9TradeTextShort" );
									}
									
									PhantomShortOn = false;	
									PhantomShortFirstTime = false;
									Print("Permanent Phantom Short Box" + "       " + Convert.ToString(CurrentBars[0]));
								}	
					   }	
				
				
				
				
		    Values[0][0] = 	line0;      
            Values[1][0] = 	line1;      
            Values[2][0] = 	line2;		
            Values[3][0] = 	line3;		
            Values[4][0] = 	line4;		
            Values[5][0] =	line5;		
            Values[6][0] =	line6;      			
            Values[7][0] = 	line7;		
            Values[8][0] = 	line8;		
			
			//Cloroed Bands
			Draw.Region(this, "tag1", CurrentBar,0, Line8, Line7, null, Brushes.Lime, 35);
			Draw.Region(this, "tag3", CurrentBar,0, Line5, Line3, null, Brushes.Gold, 35);
			Draw.Region(this, "tag2", CurrentBar,0, Line0, Line1, null, Brushes.Magenta, 35);
				
		}

		#region Properties
		
		[Range(1, int.MaxValue)]
		[Display(Name="TickRange", GroupName="Parameters", Order=1)]
		public int TickRange
		{ get; set; }

		
		[Range(1, int.MaxValue)]
		[Display(Name="TicksBetweenLines", GroupName="Parameters",  Order=2)]
		public int TicksBetweenLines
		{ get; set; }

		
		[XmlIgnore]
		[Display(Name="BackRoundColorUp", GroupName="Parameters",  Order=3)]
		public Brush BackRoundColorUp
		{
			get;
			set;
		}
		[Browsable(false)]
		public string BackRoundColorUpSerialize
		{
			get { return Serialize.BrushToString(BackRoundColorUp); }
			set { BackRoundColorUp = Serialize.StringToBrush(value); }
		}			
		
		
		[XmlIgnore]
		[Display(Name="BackRoundColorDown",  GroupName="Parameters", Order=4)]
		public Brush BackRoundColorDown
		{ 
			get;
			set;
		}		
		[Browsable(false)]
		public string BackRoundColorDownSerialize
		{
			get { return Serialize.BrushToString(BackRoundColorDown); }
			set { BackRoundColorDown = Serialize.StringToBrush(value); }
		}			
		
		[XmlIgnore]
		[Display(Name="LongPhantomColor",  GroupName="Parameters", Order=5)]
		public Brush LongPhantomColor
		{ 
			get;
			set; 
		}

		[Browsable(false)]
		public string LongPhantomColorSerialize
		{
			get { return Serialize.BrushToString(LongPhantomColor); }
			set { LongPhantomColor = Serialize.StringToBrush(value); }
		}			
		
		[XmlIgnore]
		[Display(Name="ShortPhantomColor", GroupName="Parameters",  Order=6)]
		public Brush ShortPhantomColor
		{
			get;
			set; 
		}

		[Browsable(false)]
		public string ShortPhantomColorSerialize
		{
			get { return Serialize.BrushToString(ShortPhantomColor); }
			set { ShortPhantomColor = Serialize.StringToBrush(value); }
		}			
		
		[XmlIgnore]
		[Display(Name="ShowBackRoundColors",  GroupName="Parameters", Order=7)]
		public bool ShowBackRoundColors
		{ get; set; }
		
		[XmlIgnore]
		[Display(Name="ShowTradeText",  GroupName="Parameters", Order=8)]
		public bool ShowTradeText
		{ get; set; }
		
		[XmlIgnore]
		[Display(Name="ShowTradeEntryLine",  GroupName="Parameters", Order=9)]
		public bool ShowTradeEntryLine
		{ get; set; }
		
		[XmlIgnore]
		[Display(Name="ShowTradeBoxes",  GroupName="Parameters", Order=10)]
		public bool ShowTradeBoxes
		{ get; set; }
		
		[Range(1, int.MaxValue)]
		[Display(Name="TicksAwayFromBoxForText", GroupName="Parameters", Order=11)]
		public double TicksAwayFromBox
		{ get; set; }
		
		[Browsable(false)]
		[XmlIgnore]
		public Brush MidBandColor
		{ get; set; }
		
		public override string DisplayName
		{
  		get { return "CKv9WithBoxesMidBandAndPhantom"; }
		}
		
		[Browsable(false)]
		[XmlIgnore]
		public Brush BackRoundColor
		{ get; set; }
		
		[Browsable(false)]
		[XmlIgnore()]
		public Series<double> Line0
		{
			get { return Values[0]; }
		}

		[Browsable(false)]
		[XmlIgnore()]
		public Series<double> Line1
		{
			get { return Values[1]; }
		}

		[Browsable(false)]
		[XmlIgnore()]
		public Series<double> Line2
		{
			get { return Values[2]; }
		}

		[Browsable(false)]
		[XmlIgnore()]
		public Series<double> Line3
		{
			get { return Values[3]; }
		}

		[Browsable(false)]
		[XmlIgnore()]
		public Series<double> Line4
		{
			get { return Values[4]; }
		}

		[Browsable(false)]
		[XmlIgnore()]
		public Series<double> Line5
		{
			get { return Values[5]; }
		}

		[Browsable(false)]
		[XmlIgnore()]
		public Series<double> Line6
		{
			get { return Values[6]; }
		}

		[Browsable(false)]
		[XmlIgnore()]
		public Series<double> Line7
		{
			get { return Values[7]; }
		}

		[Browsable(false)]
		[XmlIgnore()]
		public Series<double> Line8
		{
			get { return Values[8]; }
		}
		#endregion

	}
}

#region NinjaScript generated code. Neither change nor remove.

namespace NinjaTrader.NinjaScript.Indicators
{
	public partial class Indicator : NinjaTrader.Gui.NinjaScript.IndicatorRenderBase
	{
		private CKv9WithBoxesMidBandAndPhantom[] cacheCKv9WithBoxesMidBandAndPhantom;
		public CKv9WithBoxesMidBandAndPhantom CKv9WithBoxesMidBandAndPhantom()
		{
			return CKv9WithBoxesMidBandAndPhantom(Input);
		}

		public CKv9WithBoxesMidBandAndPhantom CKv9WithBoxesMidBandAndPhantom(ISeries<double> input)
		{
			if (cacheCKv9WithBoxesMidBandAndPhantom != null)
				for (int idx = 0; idx < cacheCKv9WithBoxesMidBandAndPhantom.Length; idx++)
					if (cacheCKv9WithBoxesMidBandAndPhantom[idx] != null &&  cacheCKv9WithBoxesMidBandAndPhantom[idx].EqualsInput(input))
						return cacheCKv9WithBoxesMidBandAndPhantom[idx];
			return CacheIndicator<CKv9WithBoxesMidBandAndPhantom>(new CKv9WithBoxesMidBandAndPhantom(), input, ref cacheCKv9WithBoxesMidBandAndPhantom);
		}
	}
}

namespace NinjaTrader.NinjaScript.MarketAnalyzerColumns
{
	public partial class MarketAnalyzerColumn : MarketAnalyzerColumnBase
	{
		public Indicators.CKv9WithBoxesMidBandAndPhantom CKv9WithBoxesMidBandAndPhantom()
		{
			return indicator.CKv9WithBoxesMidBandAndPhantom(Input);
		}

		public Indicators.CKv9WithBoxesMidBandAndPhantom CKv9WithBoxesMidBandAndPhantom(ISeries<double> input )
		{
			return indicator.CKv9WithBoxesMidBandAndPhantom(input);
		}
	}
}

namespace NinjaTrader.NinjaScript.Strategies
{
	public partial class Strategy : NinjaTrader.Gui.NinjaScript.StrategyRenderBase
	{
		public Indicators.CKv9WithBoxesMidBandAndPhantom CKv9WithBoxesMidBandAndPhantom()
		{
			return indicator.CKv9WithBoxesMidBandAndPhantom(Input);
		}

		public Indicators.CKv9WithBoxesMidBandAndPhantom CKv9WithBoxesMidBandAndPhantom(ISeries<double> input )
		{
			return indicator.CKv9WithBoxesMidBandAndPhantom(input);
		}
	}
}

#endregion
