#region Using declarations
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Input;
using System.Windows.Media;
using System.Xml.Serialization;
using NinjaTrader.Cbi;
using NinjaTrader.Gui;
using NinjaTrader.Gui.Chart;
using NinjaTrader.Gui.SuperDom;
using NinjaTrader.Gui.Tools;
using NinjaTrader.Data;
using NinjaTrader.NinjaScript;
using NinjaTrader.Core.FloatingPoint;
using NinjaTrader.NinjaScript.Indicators;
using NinjaTrader.NinjaScript.DrawingTools;
#endregion

//This namespace holds Strategies in this folder and is required. Do not change it. 
namespace NinjaTrader.NinjaScript.Strategies
{
	public class CKv10Strategy : Strategy
	{
		 private double line0;
		 private double line8;
		 private double MidBandDir;
		 private double BackRoundDir; 
		 bool MidBandisBlue   =  false;
   	   	 bool MidBandisRed  = false;
		 bool BackRoundUp  = false;
		 bool BackRoundDn  = false;
		 private double lastMidBandLongHigh;
		 private double LastMidBandShortLow;
		 bool MidBandLongOn = false;
		 bool MidBandLongFirstTime = false;
		 bool MidBandShortOn = false;
		 bool MidBandShortFirstTime = false;
		private double 				LastPhantomLongHigh;
		private double 				LastPhantomShortLow;
		bool PhantomLongOn = 		false;
	    bool PhantomShortOn = 		false;
		bool PhantomLongFirstTime = false;
		bool PhantomShortFirstTime= false;

		
		
		protected override void OnStateChange()
			
			
			
		{
			if (State == State.SetDefaults)
			{
				Description									= @"Enter the description for your new custom Strategy here.";
				Name										= "CKv10Strategy";
				Calculate									= Calculate.OnBarClose;
				EntriesPerDirection							= 1;
				EntryHandling								= EntryHandling.AllEntries;
				IsExitOnSessionCloseStrategy				= true;
				ExitOnSessionCloseSeconds					= 30;
				IsFillLimitOnTouch							= false;
				MaximumBarsLookBack							= MaximumBarsLookBack.TwoHundredFiftySix;
				OrderFillResolution							= OrderFillResolution.Standard;
				Slippage									= 0;
				StartBehavior								= StartBehavior.WaitUntilFlat;
				TimeInForce									= TimeInForce.Gtc;
				TraceOrders									= false;
				RealtimeErrorHandling						= RealtimeErrorHandling.StopCancelClose;
				StopTargetHandling							= StopTargetHandling.PerEntryExecution;
				BarsRequiredToTrade							= 20;
				// Disable this property for performance gains in Strategy Analyzer optimizations
				// See the Help Guide for additional information
				IsInstantiatedOnEachOptimizationIteration	= true;
				StrategyStartTime				= DateTime.Parse("08:00", System.Globalization.CultureInfo.InvariantCulture);
				StrategyEndTime					= DateTime.Parse("11:00", System.Globalization.CultureInfo.InvariantCulture);
				StopTicks						= 10;
				TargetTicks						= 10;
				TickRange				 		= 48;
				TicksBetweenLines				= 6;
				MidBandDir                      = 0;
				BackRoundDir					= 0;
				ShowBackRoundColors				= true;
				BackRoundUp						= false;
				BackRoundDn						= false;
				LongTradesEnable				= true;
				ShortTradesEnable				= true;
		
			}
			else if (State == State.Configure)
			{
				SetStopLoss(@"MidBandShort", CalculationMode.Ticks,StopTicks, false);
				SetProfitTarget(@"MidBandShort", CalculationMode.Ticks,TargetTicks	);
				SetStopLoss(@"MidBandLong", CalculationMode.Ticks, StopTicks, false);
				SetProfitTarget(@"MidBandLong", CalculationMode.Ticks, TargetTicks	);
				SetStopLoss(@"PhantomShort", CalculationMode.Ticks,StopTicks, false);
				SetProfitTarget(@"PhantomShort", CalculationMode.Ticks,TargetTicks	);
				SetStopLoss(@"PhantomLong", CalculationMode.Ticks, StopTicks, false);
				SetProfitTarget(@"PhantomLong", CalculationMode.Ticks, TargetTicks	);
			}
		}

		protected override void OnBarUpdate()
		{
			 if (CurrentBar == 5)
			{
                line8 = Close[0];
                line0 = Close[0];
            }
			// if lines are moving up
            if (High[0] > line8) 
            {
                line8 = High[0];
                line0 = line8 - TickRange * TickSize;
				MidBandisRed = false;
				MidBandDir = 1;
				MidBandShortFirstTime = true;
				MidBandLongFirstTime = true;
				PhantomLongFirstTime = true;
					{
					MidBandisBlue  = true;
					}
  					if (ShowBackRoundColors	)
					{
					BackBrushAll = BackRoundColor;
					}	
				BackRoundDir =1;
		    }
			//if lines are going down
            else if (Low[0] < line0)
            {
                line0 = Low[0];
                line8 = line0 + TickRange * TickSize;
				MidBandDir = 0;
				MidBandLongFirstTime = true;
				MidBandShortFirstTime = true;
				PhantomShortFirstTime = true;
					{
					MidBandisRed  = true;
					}
					if (ShowBackRoundColors	)
					{
					BackBrushAll = BackRoundColor;
					}	
				BackRoundDir  = 0;
				
            }

			double line1 = (line0 + (TicksBetweenLines*1) * TickSize);
            double line2 = (line0 + (TicksBetweenLines*2) * TickSize);
            double line3 = (line0 + (TicksBetweenLines*3) * TickSize);
		    double line4 = (line0 + (TicksBetweenLines*4) * TickSize);
		    double line5 = (line0 + (TicksBetweenLines*5) * TickSize);
            double line6 = (line0 + (TicksBetweenLines*6) * TickSize);
            double line7 = (line0 + (TicksBetweenLines*7) * TickSize);
			

				// box drawing code////////////////////////////////////////////////////////////////////
				
				// for long mid band boxes
				if((BackRoundDir ==1) && (MidBandLongFirstTime))
				{
					if((Close[0] < (line5 -.02)) && (Low[0] < Low[1]) && (Close[0] > line3))
					{
					lastMidBandLongHigh = High[1];	
					MidBandLongOn = true;	
					}
					if(Close[0] < line3)
					{
				   	MidBandLongOn = false;	
					MidBandLongFirstTime = false;
						
					}
					
					if((Close[0] > lastMidBandLongHigh) && (MidBandLongOn))
					{
					
						if ((Position.MarketPosition == MarketPosition.Flat)
						 && (Times[0][0].TimeOfDay > StrategyStartTime.TimeOfDay)
						 && (Times[0][0].TimeOfDay < StrategyEndTime.TimeOfDay))
						{
							if(LongTradesEnable)
							{
						 EnterLong("MidBandLong");
							Print("midBandLong");
							}
						}// store the highest bars ago value
  						int lowestBarsAgo = LowestBar(Low,6 );
   						//evaluate high price from highest bars ago value
  						double lowestPrice = Low[lowestBarsAgo];  
						MidBandLongOn = false;	
						MidBandLongFirstTime = false;
					}
					
				}
					//for phantom long boxes////////////////////////
					
					if ((BackRoundDir == 1 ) && (PhantomLongFirstTime))
					{	
						if((Close[0] < (line2 -.01)) && (Low[0] < Low[1]) && (Close[0] > line0))
				   		{
						LastPhantomLongHigh = High[1];	
						Print(LastPhantomLongHigh);	
						PhantomLongOn = true;
						PhantomShortOn	= false;	
						}	
					 		  if((Close[0] > LastPhantomLongHigh) && (PhantomLongOn))
								{
									if ((Position.MarketPosition == MarketPosition.Flat)
								  	&& (Times[0][0].TimeOfDay > StrategyStartTime.TimeOfDay)
						 			&& (Times[0][0].TimeOfDay < StrategyEndTime.TimeOfDay))
									{
									if(LongTradesEnable)
									{
						 			EnterLong("PhantomLong");
									}	
									}
									// store the highest bars ago value
  									int lowestBarsAgo = LowestBar(Low,6 );
   									//evaluate high price from highest bars ago value
  									double lowestPrice = Low[lowestBarsAgo];  
									PhantomLongOn = false;	
									PhantomLongFirstTime = false;
									}	
					   }
					
					
				// for mid band short boxes
				
				if((BackRoundDir ==0) && (MidBandShortFirstTime))
				{
					if((Close[0] > (line3 +.02)) && (High[0] > High[1]) && (Close[0] < line5))
					{
					LastMidBandShortLow = Low[1];	
					MidBandShortOn = true;	
					}
					if(Close[0] > line5)
					{
				    MidBandShortOn = false;	
					MidBandShortFirstTime = false;	
						
				}
					
					if((Close[0] < LastMidBandShortLow) && (MidBandShortOn))
					{
						if ((Position.MarketPosition == MarketPosition.Flat)
					 	&& (Times[0][0].TimeOfDay > StrategyStartTime.TimeOfDay)
						&& (Times[0][0].TimeOfDay < StrategyEndTime.TimeOfDay))
						{
						if(ShortTradesEnable)
						{
						EnterShort("MidBandShort");
						}	
						}
						// store the highest bars ago value
  						int highestBarsAgo = HighestBar(High,6 );
   						//evaluate high price from highest bars ago value
  						double highestPrice = High[highestBarsAgo];  
						MidBandShortOn = false;	
						MidBandShortFirstTime = false;
				    	}
						else
						{
					}
				}
				
				if ((BackRoundDir == 0 ) && (PhantomShortFirstTime))
					{	
						if((Close[0] > (line6 -.01)) && (High[0] > High[1]) && (Close[0] < line8))
				   		{
						LastPhantomShortLow = Low[1];	
						PhantomShortOn = true;	
						PhantomLongOn = false;	
						}	
					 		  if((Close[0] < LastPhantomShortLow) && (PhantomShortOn))
								{
									
								 	if ((Position.MarketPosition == MarketPosition.Flat)
						 			&& (Times[0][0].TimeOfDay > StrategyStartTime.TimeOfDay)
						 			&& (Times[0][0].TimeOfDay < StrategyEndTime.TimeOfDay))
								{
									if(ShortTradesEnable)
									{	
									EnterShort("PhantomShort");
									}
					}
									
						// store the highest bars ago value
  									int highestBarsAgo = HighestBar(High,6 );
   									//evaluate high price from highest bars ago value
  									double highestPrice = High[highestBarsAgo];  
									PhantomShortOn = false;	
									PhantomShortFirstTime = false;
									
								}	
					   }	
				
		}
		
		#region Properties
		
		[NinjaScriptProperty]
		[PropertyEditor("NinjaTrader.Gui.Tools.TimeEditorKey")]
		[Display(Name="StrategyStartTime", Order=1, GroupName="Parameters")]
		public DateTime StrategyStartTime
		{ get; set; }

		[NinjaScriptProperty]
		[PropertyEditor("NinjaTrader.Gui.Tools.TimeEditorKey")]
		[Display(Name="StrategyEndTime", Order=2, GroupName="Parameters")]
		public DateTime StrategyEndTime
		{ get; set; }
		
		[NinjaScriptProperty]
		[Range(1, int.MaxValue)]
		[Display(Name="StopTicks", Order=3, GroupName="Parameters")]
		public int StopTicks
		{ get; set; }

		[NinjaScriptProperty]
		[Range(1, int.MaxValue)]
		[Display(Name="TargetTicks", Order=4, GroupName="Parameters")]
		public int TargetTicks
		{ get; set; }

		
		//[NinjaScriptProperty]
		[Range(1, int.MaxValue)]
		[Display(Name="TickRange", Order=5, GroupName="Parameters")]
		public int TickRange
		{ get; set; }

		//[NinjaScriptProperty]
		[Range(1, int.MaxValue)]
		[Display(Name="TicksBetweenLines", Order=6, GroupName="Parameters")]
		public int TicksBetweenLines
		{ get; set; }

		

			
		//[NinjaScriptProperty]
		[XmlIgnore]
		[Display(Name="ShowBackRoundColors", Order=7, GroupName="Parameters")]
		public bool ShowBackRoundColors
		{ get; set; }
		
		[XmlIgnore]
		[Display(Name="ShortTradesEnable", Order=8, GroupName="Parameters")]
		public bool ShortTradesEnable
		{ get; set; }
		
		[XmlIgnore]
		[Display(Name="LongTradesEnable", Order=9, GroupName="Parameters")]
		public bool LongTradesEnable
		{ get; set; }
		
		
		[Browsable(false)]
		[XmlIgnore]
		public Brush MidBandColor
		{ get; set; }
		
		public override string DisplayName
		{
  		get { return "CKv10Strategy"; }
		}

		//[NinjaScriptProperty]
		
		[Browsable(false)]
		[XmlIgnore]
		public Brush BackRoundColor
		{ get; set; }
		
		[Browsable(false)]
		[XmlIgnore]
		public Series<double> Line0
		{
			get { return Values[0]; }
		}

		[Browsable(false)]
		[XmlIgnore]
		public Series<double> Line1
		{
			get { return Values[1]; }
		}

		[Browsable(false)]
		[XmlIgnore]
		public Series<double> Line2
		{
			get { return Values[2]; }
		}

		[Browsable(false)]
		[XmlIgnore]
		public Series<double> Line3
		{
			get { return Values[3]; }
		}

		[Browsable(false)]
		[XmlIgnore]
		public Series<double> Line4
		{
			get { return Values[4]; }
		}

		[Browsable(false)]
		[XmlIgnore]
		public Series<double> Line5
		{
			get { return Values[5]; }
		}

		[Browsable(false)]
		[XmlIgnore]
		public Series<double> Line6
		{
			get { return Values[6]; }
		}

		[Browsable(false)]
		[XmlIgnore]
		public Series<double> Line7
		{
			get { return Values[7]; }
		}

		[Browsable(false)]
		[XmlIgnore]
		public Series<double> Line8
		{
			get { return Values[8]; }
		}
		
		#endregion
	}
}
